Program Graphics3D;
{$R-,S-}
Uses Crt,Dos,Graph,Base;
Const
 MaxPts        = 11;
 MaxPolys      = 30;
 DEG           = PI/180;
Type
 xyzw          = (x,y,z,w);
 Point         = array[xyzw] of real;
 Point3DType   = array[x..z] of real;
 MatrixType    = array[1..4,1..4] of real;
 PolygonType   = array[1..MaxPts+1] of PointType;
 Polygon3DType = record
                  numPts : word;
                  coords : array[1..MaxPts] of Point3DType;
                 end;
 Object3DType   = record
                   numPolys : word;
                   poly : array[1..MaxPolys] of Polygon3DType;
                  end;
 DepthType = record
              num   : word;
              depth : real;
             end;
 DepthListType = array[1..MaxPolys] of DepthType;
Const
 I :  MatrixType = ( (1,0,0,0) , (0,1,0,0) , (0,0,1,0) , (0,0,0,1) );
Var
 Gd, Gm                          : Integer;
 MaxX,MaxY                       : Integer;
 CenterX,CenterY                 : Integer;
 Color,BkColor                   : Word;
 FillColor                       : Word;
 VPN,VUP,COP                     : Point;
 u,v,CENT,P,Pprime,VRPprime      : Point;
 tempvect,center                 : Point;
 Tr,Rot,Sc,Sh,ViewMat            : MatrixType;
 scalar                          : Real;
 index                           : Xyzw;
 obj                             : Object3DType;
 FillFlag,flag                   : Boolean;
 ObjectExists                    : Boolean;
 DepthUpToDate                   : Boolean;
 Parallel                        : Boolean;
 AnimOFF,GraphMode               : Boolean;
 ch                              : Char;
 D                               : Real;
 DepthList                       : DepthListType;
 a                               : MenuStr;
 ErasePointer                    : Pointer;
 Choose                          : Byte;
{}
Function Dot_Prod(v1,v2 : Point) : real;
 begin
  Dot_Prod := v1[x]*v2[x] + v1[y]*v2[y] + v1[z]*v2[z];
 end;
{}
Procedure Cross_Prod(v1,v2 : Point; var result : Point);
 begin
  result[x] := v1[y]*v2[z] - v1[z]*v2[y];
  result[y] := v1[z]*v2[x] - v1[x]*v2[z];
  result[z] := v1[x]*v2[y] - v1[y]*v2[x];
 end;
{}
Procedure Normalize(var v1 : Point);
 var
  length : real;
 begin
  length := sqrt(Dot_Prod(v1,v1));
  for index := x to z do v1[index] := v1[index]/length;
 end;
{}
Procedure Multiply_Mat(A,B : MatrixType; var C : MatrixType);
 var
  i,j,k : integer;
 begin
  for i := 1 to 4 do
   for j := 1 to 4 do
    begin
     C[i,j] := 0;
     for k := 1 to 4 do C[i,j] := C[i,j] + A[i,k] * B[k,j];
    end;
 end;
{}
Procedure Multiply_Vec(A : MatrixType; v1 : Point; var v2 : Point);
 var
  i : xyzw;
  j : integer;
 begin
  for i := x to w do
   begin
    j := ord(i) + 1;
    v2[i] := v1[x]*A[1,j] + v1[y]*A[2,j] + v1[z]*A[3,j] + v1[w]*A[4,j];
   end;
 end;
{}
Procedure Subtract_Vec(v1,v2 : Point; var result : Point);
 begin
  result[x] := v1[x] - v2[x];
  result[y] := v1[y] - v2[y];
  result[z] := v1[z] - v2[z];
  result[w] := 1;
 end;
{}
Procedure GetCenter(var p : Point3DType);
 var
  i,j         : word;
  TotalNumPts : word;
 begin
  TotalNumPts := 0;
  p[x] := 0; p[y] := 0;   p[z] := 0;
  with obj do
  for i := 1 to numPolys do
  with poly[i] do
   begin
    TotalNumPts := TotalNumPts + numPts;
    for j := 1 to numPts do
     for index := x to z do
      p[index] := p[index] + coords[j][index];
   end;
  for index := x to z do p[index] := p[index]/ TotalNumPts;
 end;
{}
Procedure Translate(Tx, Ty, Tz : real);
 begin
  Tr := I;
  Tr[4,1] := Tx;
  Tr[4,2] := Ty;
  Tr[4,3] := Tz;
  Multiply_Mat(ViewMat,Tr,ViewMat);
 end;
{}
Procedure Rotate(Rx , Ry, Rz : real);
 begin
  if ( Rx<>0 ) then
   begin
    Rot := I; Rx := Rx * DEG;
    Rot[2,2] := cos(Rx);
    Rot[2,3] := sin(Rx);
    Rot[3,2] := -Rot[2,3];
    Rot[3,3] := Rot[2,2];
    Multiply_Mat(ViewMat,Rot,ViewMat);
   end;
  if ( Ry<>0 ) then
   begin
    Rot := I; Ry := Ry * DEG;
    Rot[1,1] := cos(Ry);
    Rot[1,3] := sin(Ry);
    Rot[3,1] := -Rot[1,3];
    Rot[3,3] := Rot[1,1];
    Multiply_Mat(ViewMat,Rot,ViewMat);
   end;
  if ( Rz<>0 ) then
   begin
    Rot := I; Rz := Rz * DEG;
    Rot[1,1] := cos(Rz);
    Rot[1,2] := sin(Rz);
    Rot[2,1] := -Rot[1,2];
    Rot[2,2] := Rot[1,1];
    Multiply_Mat(ViewMat,Rot,ViewMat);
   end;
 end;
{}
Procedure Scale(Sx, Sy, Sz : real);
 begin
  Sc := I;
  if Sx<>0 then Sc[1,1] := Sx;
  if Sy<>0 then Sc[2,2] := Sy;
  if Sz<>0 then Sc[3,3] := Sz;
  Multiply_Mat(ViewMat,Sc,ViewMat);
 end;
{}
Procedure Shear(dir : word; a,b : real);
 begin
  Sh := I;
  case dir of
   0 : begin Sh[1,2] := a; Sh[1,3] := b; end;
   1 : begin Sh[2,1] := a; Sh[2,3] := b; end;
   2 : begin Sh[3,1] := a; Sh[3,2] := b; end;
  end;
  Multiply_Mat(ViewMat,Sh,ViewMat);
 end;
{}
Procedure TransformObject;
 var
  i,j : word;
  p   : Point;
 begin
  DepthUpToDate := FALSE;
  with obj do
  for i := 1 to numPolys do
   with poly[i] do
    for j := 1 to numPts do
     begin
      p[x] := coords[j][x]; p[y] := coords[j][y]; p[z] := coords[j][z];
      p[w] := 1;
      Multiply_Vec(ViewMat,p,p);
      coords[j][x] := p[x]; coords[j][y] := p[y]; coords[j][z] := p[z];
     end;
 end;
{}
Procedure FillDepthList;
 var
   i : word;
 begin
   with obj do
   for i := 1 to numPolys do DepthList[i].num := i;
   DepthUpToDate := FALSE;
 end;
{}
 Procedure UpdateObject;
 {}
  Function DepthOf( po : Polygon3DType) : real;
   var
    depth : real;
    i    : word;
   begin
    Depth := 0;
    with po do
     begin
      for i := 1 to numPts do Depth := Depth + coords[i][z];
      DepthOf := Depth/po.numPts;
     end;
   end;
 {}
  Procedure UpdateDepthList;
   var
    i : word;
   begin
    with obj do
    for i := 1 to numPolys do
     begin
      DepthList[i].num := i;
      DepthList[i].depth := DepthOf(poly[i]);
     end;
   end;
 {}
  Procedure SortDepthList;
   {}
    Procedure sort( l,r : word);
     var
      i,j : word;
      x   : real;
      y   : DepthType;
     begin
      i := l; j := r; x := DepthList[(i+j) DIV 2].depth;
      repeat
       while DepthList[i].depth > x do i := i+1;
       while x > DepthList[j].depth do j := j-1;
       if i <= j then
        begin
         y := DepthList[i];DepthList[i] := DepthList[j];DepthList[j] := y;
         i := i + 1; j := j - 1;
        end;
      until i > j;
      if l < j then sort(l,j);
      if i < r then sort(i,r);
     end;
   {}
    begin
     sort(1,obj.numPolys);
    end;
 begin
  if(not DepthUpToDate) then
   begin
    UpdateDepthList;
    SortDepthList;
    DepthUpToDate := TRUE;
   end;
 end;
{}
Procedure DrawObject;
 var
  i,j     : word;
  polygon : PolygonType;
  pt      : Point;
  s       : real;
 begin
  if (FillFlag) then UpdateObject;
  with obj do
  for i := 1 to numPolys do
  with poly[DepthList[i].num] do
   begin
    for j := 1 to numPts do
     begin
      if (parallel) or (coords[j][z] = 0) then s:=1 else s:=D/coords[j][z];
      polygon[j].x := centerX + Round(coords[j][x]*s);
      polygon[j].y := centerY - Round(coords[j][y]*s);
     end;
    polygon[numPts+1] := polygon[1];{This line and the +1 could be removed}
    DrawPoly( numPts+1, Polygon );
    if (FillFlag) then FillPoly( numPts+1, Polygon );
   end;
  if (AnimOFF) then
   begin
    SetFillStyle(1,GREEN); SetColor(WHITE);
    Bar(170,14,470,47);
    Rectangle(170,14,470,47);
    OutTextxy(180,19,'3D-Graphics by Avdeev Ilya (1998)');
    OutTextxy(230,32,'Press F1 for Help');
    SetFillStyle(1,FillColor); SetColor(Color);
   end;
 end;
{}
 Procedure InputObject;
  var
   i,j    : word;
   center : Point3DType;
   Plus   : Integer;
   s      : string;
  begin
   ClearDevice;
   SetFillStyle(1,7);
   Bar(0,200,GetMaxX,GetMaxY);
   SetTextStyle(8,0,3);
   OutTextXY((GetMaxX div 2)-200,210,'Object Creation Mode ');
   SetTextStyle(8,0,2);
   OutTextXY(30,250,'Use SPACES to seperate coordinates of a point,');
   OutTextXY(30,270,'e.g. : Instead of  (23,4.5,-17)  enter   23 4.5 -17 .');
   with obj do
    begin
     str(MaxPolys,s);
     Input('Enter number of polygons (MAX = '+s+' ) : ',numPolys,2);
     if (numPolys > MaxPolys) then numPolys := MaxPolys;
     str(MaxPts,s);
     for i := 1 to numpolys do
      with poly[i] do
       begin
        str(i,s);
        Input('Enter Number of points (MAX = '+s+' ) [Polygon '+s+']: ',numPts,1);
        if (numPts > MaxPts) then numPts := MaxPts;
        for j := 1 to numPts do
         begin
          str(j,s);
          InputRel('Enter point '+s+' : ',coords[j][x],2);
          InputRel('Enter point '+s+' : ',coords[j][y],2);
          InputRel('Enter point '+s+' : ',coords[j][z],2);
         end;
        end;
        if (numPolys <> 0) then
         begin
          ObjectExists := TRUE;
          FillDepthList;
          GetCenter(center);
          D := center[z]/2;
         end;
       end;
  end;
{}
Procedure SaveObject;
 var
  f          : file of Object3DType;
  objectname : string;
 begin
  GetMem(ErasePointer,ImageSize(0,0,500,40));
  GetImage(0,0,GetMaxX,60,ErasePointer^);
  ReadStr('Enter Object filename to Save:',objectname,2);
  Assign(f,objectname);
  Rewrite(f);
  Write(f,obj);
  Close(f);
  PutImage(0,0,ErasePointer^,0);
 end;
{}
 Procedure LoadObject;
  var
  f          : file of Object3DType;
  objectname : string;
  center     : Point3DType;
 {}
  Function FileExists(FileName: string) : Boolean;
   var
    f: file;
   begin
    {$I-}
    Assign(f, FileName);
    Reset(f);
    Close(f);
    {I+}
    FileExists := (IOResult = 0) and (FileName <> '');
   end;
 {}
 begin
  objectname:=FileList('*.3do*',2);
  if(FileExists(objectname)) then
   begin
    Assign(f,objectname);
    Reset(f);
    Read(f,obj);
    Close(f);
    ObjectExists := TRUE;
    FillDepthList;
    GetCenter(center);
    D := center[z]/2;
   end
   else
   begin
    SetColor(14);
    SetFillStyle(1,1);
    Bar(0,0,500,40);
    Rectangle(0,0,500,40);
    SetTextStyle(0,0,1);
    OutTextXY(10,10,'Sorry, Can''t Load Object. (FileName does not exist.)');
    OutTextXY(10,20,'Press any key to continue.');
    Readkey;
   end;
end;
{}
Procedure Display;
 var
  center  : Point3DType;
  ch      : char;
  page    : word;
  Col,Row : word;
  height  : word;
  {}
   Procedure Initialize;
    begin
     CloseGraph;
     Gd := EGA; Gm := EGAHI;
     InitGraph(Gd, Gm, '');
     GraphMode:=False;
     if GraphResult <> grOk then
      begin
       clrscr;
       writeln('This program requires an EGA or Higher card,');
       writeln('Also Check that the file EGAVGA.BGI is present.');
       Halt(1);
      end;
     SetColor(Color);
     SetBkColor(BkColor);
     SetFillStyle(1,FillColor);
     MaxX := GetMaxX; MaxY := GetMaxY;
     CenterX := MaxX shr 1; CenterY := MaxY shr 1;
     page := 0;
    end;
  {}
   Procedure Action;
    begin
     TransformObject;
     page := page + 1;
     SetActivePage(page and 1);
     ClearDevice;
     DrawObject;
     Delay(100);
     SetVisualPage(page and 1);
    end;
  {}
   Procedure Help;
    const
     vp : ViewPortType = (x1: 65; y1: 80; x2: 555; y2: 305; Clip : ClipOn);
    var
     ch : char;
  {}
   Procedure WriteOut(S : string);
    begin
     OutTextXY(Col, Row, S);
     Inc(Row, height);
    end;
  {}
    begin
     page := page + 1;
     SetActivePage(page and 1);
     ClearDevice;
     DrawObject;
     with vp do
      begin
       SetFillStyle(1,RED); SetColor(WHITE);
       Bar(x1-1,y1-1,x2+1,y2+1);
       Rectangle(x1-1,y1-1,x2+1,y2+1);
       SetViewPort(x1, y1, x2, y2, ClipOn);
       height := TextHeight('M')+2;
       Col := 5; Row := 8;
       WriteOut(' :- ');
       WriteOut('--------');
       Col := 10; Row := 38;
{       WriteOut('SPACE : Toggle between Solid And WireFrame.');}
       WriteOut('ENTER : ᯥ⨢/ࠫ쭠 樨.');
       WriteOut('3,6,9 :  梥 , , 䮭.');
       WriteOut(' +/-  : /㬥.');
       WriteOut(' 7/8  : 饭   Z.');
       WriteOut(' 4/5  : 饭   Y.');
       WriteOut(' 1/2  : 饭   X.');
       WriteOut(' Q/W  :    Z.');
       WriteOut(' A/S  :    Y.');
       WriteOut(' Z/X  :    X.');
{       WriteOut(' 0/.  : Change Position of Projection Window (D).');}
       Inc(Row,Height);
       WriteOut('  R   : ⮯.');
       Inc(Row,Height);
       WriteOut(' ESC  : 室   .');
       Inc(Row,2*Height);
       if (Parallel) then WriteOut('饥 ﭨ = ࠫ쭠 .')
       else WriteOut('饥 ﭨ = ᯥ⨢ .');
      end;
     SetVisualPage(page);
     Readkey;
     SetViewPort(0, 0, MaxX, MaxY, ClipOn);
     SetFillStyle(1,FillColor); SetColor(Color);
    end;
  {}
   Procedure Animate;
    begin
     Rotate(5,7,9);
     Translate(center[x],center[y],center[z]);
     AnimOFF := TRUE;  { Could be AnimOFF := FALSE;}
     repeat Action until Keypressed;
     AnimOFF := TRUE;
     ViewMat := I;
     Action;
     Readkey;
    end;
  {}
 begin
  Initialize;
  ViewMat := I;
  Action;
  repeat
   ViewMat := I;
   flag := FALSE;
   GetCenter(center);
   Translate(-center[x],-center[y],-center[z]);
   ch := readkey;if ch=#0 then ch:=Readkey;
   case ch of
    '+' : begin Scale(1.1,1.1,1.1); flag := TRUE; end;
    '-' : begin Scale(1/1.1,1/1.1,1/1.1); flag := TRUE; end;
    '7' : begin Rotate(0,0,5); flag := TRUE; end;
    '8' : begin Rotate(0,0,-5); flag := TRUE; end;
    '4' : begin Rotate(0,5,0); flag := TRUE; end;
    '5' : begin Rotate(0,-5,0); flag := TRUE; end;
    '1' : begin Rotate(5,0,0); flag := TRUE; end;
    '2' : begin Rotate(-5,0,0); flag := TRUE; end;
    '0' : begin D := D - 10; flag := TRUE; end;
    '.' : begin D := D + 10; flag := TRUE; end;
    'W','w' : begin Translate(0,0,10); flag := TRUE; end;
    'Q','q' : begin Translate(0,0,-10); flag := TRUE; end;
    'S','s' : begin Translate(0,10,0); flag := TRUE; end;
    'A','a' : begin Translate(0,-10,0); flag := TRUE; end;
    'X','x' : begin Translate(10,0,0); flag := TRUE; end;
    'Z','z' : begin Translate(-10,0,0); flag := TRUE; end;
    ' '     : begin FillFlag := not FillFlag; flag := TRUE; end;
    chr(13) : begin Parallel := not Parallel; flag := TRUE; end;
    chr(59) : begin Help; flag := TRUE; end;
    'R','r' : begin Animate; end;
    '3'     : begin Color := (Color+1) and 15; SetColor(Color); flag := TRUE; end;
    '6'     : begin FillColor := (FillColor+1) and 15; SetFillStyle(1,FillColor); flag := TRUE; end;
    '9'     : begin BkColor := (BkColor+1) and 15; SetBkColor(BkColor); end;
   end;
   if (flag) then
    begin
     Translate(center[x],center[y],center[z]);
     Action;
    end;
  until ( ch = chr(27) );
  RestoreCrtMode;
 end;
{}
Procedure Status;
 var
  center  : Point3DType;
  ch      : char;
  message : string;
  p       : pointer;
 begin
  SetFillStyle(1,7);
  Bar(0,0,GetMaxX,GetMaxY);
  SetColor(1);
  Rectangle(0,0,GetMaxX,GetMaxY);
  Rectangle(10,10,GetMaxX-10,GetMaxY-10);
  SetTextStyle(8,0,4);
  OutTextXY((GetMaxX div 2)-100,10,'Status');
  Line((GetMaxX div 2)-100,13+TextHeight('Status'),(GetMaxX div 2)-100+TextWidth('Status'),13+TextHeight('Status'));
  SetTextStyle(8,0,1);
  str(d:6:2,message);
  OutTextXY(20,60,'Depth of Perspective Projection plane (D) = '+message);
  GetCenter(center);
  str(center[z]:6:2,message);
  OutTextXY(20,80,'Depth of Perspective Projection plane (D) = '+message);
  OutTextXY(20,100,'If you want to change the current Depth of the');
  OutTextXY(20,120,'Perspective Projection plane then press ''D'' ,else');
  OutTextXY(20,140,'press any other key to return to the Main Menu.');
  ch := readkey;
  if (ch = 'D') or (ch = 'd') then
   begin
    GetMem(P,ImageSize(10,10,GetMaxX,60));   { Allocate memory on heap }
    GetImage(10,10,GetMaxX,60,P^);
    InputRel('Enter New Depth of Perspective Projection Plane''D''=',d,1);
    PutImage(10,10,P^,NormalPut);
   end;
   Readkey;
   ClearDevice;
 end;
{}
Procedure Transform;
 var
  a,b,c  : Real;
  dir    : Word;
  ch     : Char;
  d      : MenuStr;
  Choose : Byte;
 begin
  ViewMat := I;
  repeat
   ClearDevice;
   d[1]:='Translation';
   d[2]:='Rotation';
   d[3]:='Scale';
   d[4]:='Shear';
   d[5]:='Display';
   d[6]:='Back to Main Menu';
   Choose:=Menu('Edition Menu',d,6,3);
   case Choose of
    1 : begin
           InputRel('Enter Displacement DeltaX',a,2);
           InputRel('Enter Displacement DeltaY',b,2);
           InputRel('Enter Displacement DeltaZ',c,2);
           Translate(a,b,c);
          end;
    2 : begin
           InputRel('Enter Angle in degrees ThetaX',a,2);
           InputRel('Enter Angle in degrees ThetaY',b,2);
           InputRel('Enter Angle in degrees ThetaZ',c,2);
           Rotate(a,b,c);
          end;
    3 : begin
           InputRel('Enter Scale ScaleX',a,2);
           InputRel('Enter Scale ScaleY',b,2);
           InputRel('Enter Scale ScaleZ',c,2);
           Scale(a,b,c);
          end;
    4 : begin
           Input('Enter Shear axis ( 0=X or 1=Y or 2=Z ) = ',dir,2);
           InputRel('Enter Shear Values : a = ',a,2);
           InputRel('Enter Shear Values : b = ',b,2);
           Shear(dir,a,b);
          end;
    5 : begin
           TransformObject;
           Display;
           ViewMat := I;
          end;
   end;
  until (choose = 6);
  TransformObject;
 end;
{}
Procedure Setup;
begin
        ObjectExists := FALSE;
        Parallel := FALSE;
        FillFlag := FALSE;
        AnimOFF := TRUE;
        Color := WHITE;
        BkColor := BLACK;
        FillColor := BLUE;
end;
{}
{}
Begin {main}
{  AnaliseComputer;}
  Setup;
  GraphMode:=False;
  Init(2,'');
{  Title;}
  CloseGraph;
  Init(1,'');
  SetTextStyle(8,0,6);
  OutTextXY(100,200,'3D-Animator');
{  ClearBuffer;}
  SnowGo;
  CloseGraph;
  while KeyPressed do ch:=Readkey;
  repeat
   a[1]:='Create Object ';
   a[2]:='Load Object ';
   a[3]:='Save Object ';
   a[4]:='Status ';
   a[5]:='Display Object ';
   a[6]:='Transform Object ';
   a[7]:='Quit ';
   if (GraphMode = False) then begin CloseGraph;Init(1,'');end;
   Choose:=Menu('  main menu',a,7,3);
   flag := FALSE;
   GraphMode:=True;
   case Choose of
    1 : InputObject;
    2 : LoadObject;
    3 : if( ObjectExists ) then SaveObject else flag := TRUE;
    4 : if( ObjectExists ) then Status else flag := TRUE;
    5 : if( ObjectExists ) then Display else flag := TRUE;
    6 : if( ObjectExists ) then Transform else flag := TRUE;
    7 : begin CloseGraph;WriteLn;WriteLn(' Coded By Avdeev Ilya');Halt;end;
   end;
   if (flag) then
    begin
     SetColor(14);
     SetFillStyle(1,1);
     GetMem(ErasePointer,ImageSize(0,0,500,40));
     GetImage(0,0,500,40,ErasePointer^);
     Bar(0,0,500,40);
     Rectangle(0,0,500,40);
     SetTextStyle(0,0,1);
     OutTextXY(10,10,'Try Loading or Creating an Object first.');
     OutTextXY(10,20,'Press any key to continue.');
     Readkey;
     PutImage(0,0,ErasePointer^,0);
    end;
  until 1=0;
End.